﻿using System;
using System.Collections.Generic;

namespace Borepin.Model
{
    public enum ConnectionTyp
    {
        SINGLE,
        FEDERATED
    }

    public enum AuthenticationTyp
    {
        PLAIN
    }

    public class Connection
    {
        public Uri Address { get; set; }

        public DateTime LastTime { get; set; }

        public string Username { get; set; }

        public ConnectionTyp ConnectionTyp { get; set; }

        public AuthenticationTyp AuthenticationTyp { get; set; }

        public override bool Equals(object obj)
        {
            return obj is Connection connection &&
                   EqualityComparer<Uri>.Default.Equals(Address, connection.Address) &&
                   Username == connection.Username &&
                   ConnectionTyp == connection.ConnectionTyp &&
                   AuthenticationTyp == connection.AuthenticationTyp;
        }

        public override int GetHashCode()
        {
            int hashCode = -904541792;
            hashCode = hashCode * -1521134295 + EqualityComparer<Uri>.Default.GetHashCode(Address);
            hashCode = hashCode * -1521134295 + LastTime.GetHashCode();
            hashCode = hashCode * -1521134295 + EqualityComparer<string>.Default.GetHashCode(Username);
            hashCode = hashCode * -1521134295 + ConnectionTyp.GetHashCode();
            hashCode = hashCode * -1521134295 + AuthenticationTyp.GetHashCode();
            return hashCode;
        }
    }
}
